#***********************************************************************************************************************************************
#*  
#*  (C) 2009     Marek Walesiak     Uniwersytet Ekonomiczny we Wrocawiu
#*  
#*  Przykad do ksiki:
#*  "Statystyczna analiza danych z wykorzystaniem programu R", PWN, Warszawa 2009.
#*  
#*  Kod poniszy moe by modyfikowany, kopiowany i rozprowadzany na warunkach licencji GPL 2 (http://gnu.org.pl/text/licencja-gnu.html), 
#*  a w szczeglnoci pod warunkiem umieszczenia w zmodyfikowanym pliku widocznej informacji o dokonanych zmianach, wraz z dat ich dokonania. 
#*  
#***********************************************************************************************************************************************

d <- read.csv2("Paap_124_obs.csv", header=TRUE, row.names=1)
alfa <- 0.05 # Podaj poziom istotnoci
z <- as.ts(d)
t <- ts.intersect(z, C1=lag(z[,2],-1))
options(OutDec=",")
reg <- lm(log(z.S) ~ log(z.C) + log(C1) + z.E + z.K + z.P, data=t, x=TRUE)
wyn <- summary.lm(reg)
library(car)
DW <- durbin.watson(reg, alternative=c("positive"))
print(DW)
library(lmtest)
BG <- bgtest(reg, order=1, type=c("Chisq"))
print(BG)