#***********************************************************************************************************************************************
#*  
#*  (C) 2009     Micha Trzsiok     Akademia Ekonomiczna w Katowicach
#*  
#*  Przykad do ksiki:
#*  "Statystyczna analiza danych z wykorzystaniem programu R", PWN, Warszawa 2009.
#*  
#*  Kod poniszy moe by modyfikowany, kopiowany i rozprowadzany na warunkach licencji GPL 2 (http://gnu.org.pl/text/licencja-gnu.html), 
#*  a w szczeglnoci pod warunkiem umieszczenia w zmodyfikowanym pliku widocznej informacji o dokonanych zmianach, wraz z dat ich dokonania. 
#*  
#***********************************************************************************************************************************************

library(MASS)
library(class)
library(e1071)
data(iris)
names(iris) <- c("ddk","sdk","dp","sp","klasa")
attach(iris)
options(OutDec=",") 
svm.iris <- svm(klasa ~ ., data=iris, kernel = "radial", gamma=0.5, cost=10, cross=10)
print(summary(svm.iris))
# ocena jakoci klasyfikacji
y.teoret <- fitted(svm.iris) 
print("Tablica zgodnoci klasyfikacji:", quote=FALSE)
print(table(iris$klasa, y.teoret))
print("Wektory none to obserwacje o numerach:", quote=FALSE)
print(svm.iris$index)
detach(iris)